# Script: Zombify Menu
# Author: Caskio
# bind "zombify" to a key in the console to use.
# eg. bind "/" "zombify"
# ./addons/eventscripts/zombify/zombify.py

import es
import playerlib
import popuplib
import keyvalues

info = es.AddonInfo()
info.name = 'Zombify'
info.version = '3.3'
info.url = 'http://addons.eventscripts.com/addons/view/zombify'
info.basename = 'zombify'
info.author = 'Caskio'

zadmin_menu = None
zadmin_admins = None
zadmin_props = None
ezadmin = None
ezadmin_edit = None

listinge = {}
listingr = {}

player_editing = None
player_targeted = None
ezname = None

def load():
	global listinge
	global listingr
	global ezadmin_edit
   	es.regclientcmd('zombify', 'zombify/zombify_popup_check', 'This opens the menu')
   	es.regsaycmd('!zombify', 'zombify/zombify_popup_check', 'This opens the menu')
   	es.keygroupdelete('zadmin')
   	es.keygroupload('zadmin','|zombify')

	es.set('zombify_ver', '3.3')
    	es.makepublic('zombify_ver')

   	zadmin_menu = popuplib.create('zombify_menu')
   	zadmin_menu.addline('| Zombify Menu |')
   	zadmin_menu.addline('->1. Zombify a Player')
   	zadmin_menu.addline('->2. Spawn a Player (HUMAN)')
   	zadmin_menu.addline('->3. Spawn a Player (ZOMBIE)')
   	zadmin_menu.addline('->4. Spawn Props')
   	zadmin_menu.addline(' ')
   	zadmin_menu.addline('->6. Add/Edit/Remove Admins ')
   	zadmin_menu.addline(' ')
   	zadmin_menu.addline('0. Cancel')
   	zadmin_menu.menuselect = zombify_menuselect 

	zadmin_admins = popuplib.create('zadmins')
	zadmin_admins.addline('| Add/Edit Admins |')
	zadmin_admins.addline('->1. Add Admin')
	zadmin_admins.addline('->2. Edit Admin')
	zadmin_admins.addline('->3. Remove Admin')
   	zadmin_admins.addline(' ')
   	zadmin_admins.addline('0. Cancel')
	zadmin_admins.menuselect = zadmins_menuselect 

	zadmin_props = popuplib.create('zprops')
	zadmin_props.addline('| Props Menu |')
	zadmin_props.addline('->1. Crate')
	zadmin_props.addline('->2. Filling Cabinet')
	zadmin_props.addline('->3. Dryer')
	zadmin_props.addline('->4. Barrel')
	zadmin_props.addline('->5. Exploding Barrel')
	zadmin_props.addline(' ')
	zadmin_props.addline('0. Cancel')
	zadmin_props.menuselect = zprops_menuselect 


	
	ezadmin_edit = popuplib.create('eezadmins')
	ezadmin_edit.addline('| Admin |')
	ezadmin_edit.addline('->1. Add/Edit/Remove Admins - ')
	ezadmin_edit.addline('->2. Can Zombify Players - ')
	ezadmin_edit.addline('->3. Can Spawn Humans - ')
	ezadmin_edit.addline('->4. Can Spawn Zombies - ')
   	ezadmin_edit.addline('->5. Can Spawn Props - ')
	ezadmin_edit.addline(' ')
   	ezadmin_edit.addline('->9. Previous ')
   	ezadmin_edit.addline('0. Cancel')
	ezadmin_edit.menuselect = ezadmins_menuselect 

def unload():
	zadmin_menu.delete('zombify_menu')
	zadmin_admin.delete('zadmins')
	zadmin_props.delete('zprops')
	ezadmin_edit.delete('eezadmins')
	es.keygroupdelete('zadmin')

def zombify_popup_check():
	user = es.getcmduserid()
   	playersteamid = es.getplayersteamid(user)
   	access = es.keygetvalue('zadmin', playersteamid, 'name')
   	if access > 1:
		popuplib.send('zombify_menu',user)
   	else:
   	   	es.tell(user, 'You do not have permission to access this menu.')

def zombify_menuselect(userid, choice, popupid):
   	if choice == 1:
   	   	zombify_player(userid)
   	elif choice == 2:
   	   	spawn_human(userid)
   	elif choice == 3:
   	   	spawn_zombie(userid)
   	elif choice == 4:
   	   	zprops_menu(userid)
   	elif choice == 6:
   	   	addedit_menu(userid)

def zombify_player(userid):
	playersteamid = es.getplayersteamid(userid)
   	zombify_access = es.keygetvalue('zadmin', playersteamid, 'can_zombify')
   	if zombify_access == '1':
   		zombifiable = popuplib.easymenu('player_list', '_popup_choice', zombify_playerSelected)
   		zombifiable.settitle('| Select a player |') 
   		playerlist = playerlib.getPlayerList('#ct,#alive') 
   		for player in playerlist:
   		   	z_userid = int(player)
   		   	z_name = player.get('name')
   		   	zombifiable.addoption(z_userid, z_name)
   		zombifiable.send(userid) 
   	else:
   	   	es.tell(user, 'You do not have permission to access this menu.')

def zombify_playerSelected(caller, target, menuname):
   	player = playerlib.getPlayer(target)
	zombiename = player.get('name')
	es.tell(caller,'Zombifying ' + zombiename + ' !')
   	es.server.cmd('zombie_player ' + zombiename)

def addedit_menu(userid):
	playersteamid = es.getplayersteamid(userid)
   	ae_access = es.keygetvalue('zadmin', playersteamid, 'add_edit_zadmins')
   	if ae_access == '1':
		popuplib.send('zadmins',userid)
   	else:
   	   	es.tell(userid, 'You do not have permission to access this menu.')

def zprops_menu(userid):
	playersteamid = es.getplayersteamid(userid)
   	prop_access = es.keygetvalue('zadmin', playersteamid, 'canspawn_p')
   	if prop_access == '1':
		popuplib.send('zprops',userid)
   	else:
   	   	es.tell(userid, 'You do not have permission to access this menu.')

def zprops_menuselect(userid, choice, popupid):
   	if choice == 1:
   	   	spawn_crate(userid)
   	elif choice == 2:
   	   	spawn_filling_cabinet(userid)
   	elif choice == 3:
   	   	spawn_dryer(userid)
   	elif choice == 4:
   	   	spawn_barrel(userid)
   	elif choice == 5:
   	   	spawn_exploding_barrel(userid)

def spawn_crate(userid):
	es.prop_physics_create(userid, 'props_junk/wood_crate001a.mdl')
	popuplib.send('zprops',userid)

def spawn_filling_cabinet(userid):
	es.prop_physics_create(userid, 'props/cs_office/file_cabinet1.mdl')
	popuplib.send('zprops',userid)

def spawn_dryer(userid):
	es.prop_physics_create(userid, 'props/cs_militia/dryer.mdl')
	popuplib.send('zprops',userid)

def spawn_barrel(userid):
	es.prop_physics_create(userid, 'props/de_train/Barrel.mdl')
	popuplib.send('zprops',userid)

def spawn_exploding_barrel(userid):
	es.prop_physics_create(userid, 'props_c17/oildrum001_explosive.mdl')
	popuplib.send('zprops',userid)

def spawn_human(userid):
	playersteamid = es.getplayersteamid(userid)
   	hum_access = es.keygetvalue('zadmin', playersteamid, 'canspawn_h')
   	if hum_access == '1':
   		human = popuplib.easymenu('player_list2', '_popup_choice', human_playerSelected)
   		human.settitle('| Select a player |') 
   		playerlist2 = playerlib.getPlayerList('#dead') 
   		for player in playerlist2:
   		   	h_userid = int(player)
   		   	h_name = player.get('name')
   		   	human.addoption(h_userid, h_name)
   		human.send(userid) 
   	else:
   	   	es.tell(user, 'You do not have permission to access this menu.')

def human_playerSelected(caller, target, menuname):
	player = playerlib.getPlayer(target)
	zombiename = str(player.get('name'))
	es.changeteam(str(target), 3)
	es.tell(caller,'Spawning ' + zombiename + ' as a human!')
	es.server.cmd('est_Spawn ' + str(target) + ' 1')

def spawn_zombie(userid):
	playersteamid = es.getplayersteamid(userid)
   	zom_access = es.keygetvalue('zadmin', playersteamid, 'canspawn_z')
   	if zom_access == '1':
   		zombie = popuplib.easymenu('player_list3', '_popup_choice', zombie_playerSelected)
   		zombie.settitle('| Select a player |') 
   		playerlist3 = playerlib.getPlayerList('#dead') 
   		for player in playerlist3:
   		   	m_userid = int(player)
   		   	m_name = player.get('name')
   		   	zombie.addoption(m_userid, m_name)
   		zombie.send(userid) 
   	else:
   	   	es.tell(user, 'You do not have permission to access this menu.')

def zombie_playerSelected(caller, target, menuname):
	player = playerlib.getPlayer(target)
	es.changeteam(str(target), 3)
	zombiename = str(player.get('name'))
	es.tell(caller,'Spawning ' + zombiename + ' as a zombie!')
   	es.server.cmd('est_Spawn ' + str(target) + ' 1')
   	es.server.cmd('zombie_player ' + zombiename)

def zadmins_menuselect(userid, choice, popupid):
	if choice == 1:
   	   	add_zadmin(userid)
	elif choice == 2:
	   	edit_zadmin(userid)
	elif choice == 3:
	    	rem_zadmin(userid)

def add_zadmin(userid):
	azadmin = popuplib.easymenu('player_list4', '_popup_choice', zadmin_playerSelected)
   	azadmin.settitle('| Select a player |') 
   	playerlist4 = playerlib.getPlayerList('#human') 
   	for player in playerlist4:
   		a_userid = int(player)
   		a_name = player.get('name')
   		azadmin.addoption(a_userid, a_name)
   	azadmin.send(userid) 

def zadmin_playerSelected(caller, target, menuname):
	player = playerlib.getPlayer(target)
	playersteamid = es.getplayersteamid(str(target))
	zname = player.get('name')
	es.keycreate('zadmin',playersteamid)
	es.keysetvalue('zadmin',playersteamid,'name',zname)
	es.keysetvalue('zadmin',playersteamid,'add_edit_zadmins','0')
	es.keysetvalue('zadmin',playersteamid,'can_zombify','0')
	es.keysetvalue('zadmin',playersteamid,'canspawn_h','0')
	es.keysetvalue('zadmin',playersteamid,'canspawn_z','0')
	es.keysetvalue('zadmin',playersteamid,'canspawn_p','0')
	es.keygroupsave('zadmin','|zombify')

def edit_zadmin(userid):
	ezadmin = popuplib.easymenu('player_list5', '_popup_choice', ezadmin_playerSelected)
   	ezadmin.settitle('| Select a player |') 
   	adminlist = keyvalues.getKeyGroup('zadmin')
	count = 1
	for player in adminlist:       
		e_userid = count
		e_name = es.keygetvalue('zadmin', player, 'name')
		listinge[count] = (player)
		ezadmin.addoption(e_userid, e_name)
		count = count + 1
	ezadmin.send(userid) 

def ezadmin_playerSelected(caller, target, menuname):
	global player_editing
	global player_targeted
	global ezname
	player_targeted = target
	player_editing = str(listinge[target])
	ezname = es.keygetvalue('zadmin', player_editing, 'name')
	add_edit = es.keygetvalue('zadmin',player_editing,'add_edit_zadmins') 
	zombify = es.keygetvalue('zadmin',player_editing,'can_zombify')
	spawnh = es.keygetvalue('zadmin',player_editing,'canspawn_h')
	spawnz = es.keygetvalue('zadmin',player_editing,'canspawn_z')
	spawnp = es.keygetvalue('zadmin',player_editing,'canspawn_p')
	ezadmin_edit.modline(1,'| %s |' % ezname)
	ezadmin_edit.modline(2,'->1. Add/Edit/Remove Admins - %s' % add_edit)
	ezadmin_edit.modline(3,'->2. Can Zombify Players - %s' % zombify)
	ezadmin_edit.modline(4,'->3. Can Spawn Humans - %s' % spawnh)
	ezadmin_edit.modline(5,'->4. Can Spawn Zombies - %s' % spawnz)
   	ezadmin_edit.modline(6,'->5. Can Spawn Props - %s' % spawnp)
	ezadmin_edit.send(caller)

def ezadmin_playerSelected2(caller):
	add_edit = es.keygetvalue('zadmin',player_editing,'add_edit_zadmins') 
	zombify = es.keygetvalue('zadmin',player_editing,'can_zombify')
	spawnh = es.keygetvalue('zadmin',player_editing,'canspawn_h')
	spawnz = es.keygetvalue('zadmin',player_editing,'canspawn_z')
	spawnp = es.keygetvalue('zadmin',player_editing,'canspawn_p')
	ezadmin_edit.modline(1,'| %s |' % ezname)
	ezadmin_edit.modline(2,'->1. Add/Edit/Remove Admins - %s' % add_edit)
	ezadmin_edit.modline(3,'->2. Can Zombify Players - %s' % zombify)
	ezadmin_edit.modline(4,'->3. Can Spawn Humans - %s' % spawnh)
	ezadmin_edit.modline(5,'->4. Can Spawn Zombies - %s' % spawnz)
   	ezadmin_edit.modline(6,'->5. Can Spawn Props - %s' % spawnp)
	ezadmin_edit.send(caller)

def ezadmins_menuselect(userid, choice, popupid):
	add_edit = es.keygetvalue('zadmin',player_editing,'add_edit_zadmins') 
	zombify = es.keygetvalue('zadmin',player_editing,'can_zombify')
	spawnh = es.keygetvalue('zadmin',player_editing,'canspawn_h')
	spawnz = es.keygetvalue('zadmin',player_editing,'canspawn_z')
	spawnp = es.keygetvalue('zadmin',player_editing,'canspawn_p')
   	if choice == 1:
		if add_edit == '0':
   	   		es.keysetvalue('zadmin',player_editing,'add_edit_zadmins','1')
		else:
			es.keysetvalue('zadmin',player_editing,'add_edit_zadmins','0')
		es.keygroupsave('zadmin','|zombify')
		ezadmin_playerSelected2(userid)
   	elif choice == 2:
		if zombify == '0':
   	   		es.keysetvalue('zadmin',player_editing,'can_zombify','1')
		else:
			es.keysetvalue('zadmin',player_editing,'can_zombify','0')
		es.keygroupsave('zadmin','|zombify')
		ezadmin_playerSelected2(userid)
   	elif choice == 3:
		if spawnh == '0':
   	   		es.keysetvalue('zadmin',player_editing,'canspawn_h','1')
		else:
			es.keysetvalue('zadmin',player_editing,'canspawn_h','0')
		es.keygroupsave('zadmin','|zombify')
		ezadmin_playerSelected2(userid)
   	elif choice == 4:
		if spawnz == '0':
   	   		es.keysetvalue('zadmin',player_editing,'canspawn_z','1')
		else:
			es.keysetvalue('zadmin',player_editing,'canspawn_z','0')
		es.keygroupsave('zadmin','|zombify')
		ezadmin_playerSelected2(userid)
   	elif choice == 5:
		if spawnp == '0':
   	   		es.keysetvalue('zadmin',player_editing,'canspawn_p','1')
		else:
			es.keysetvalue('zadmin',player_editing,'canspawn_p','0')
		es.keygroupsave('zadmin','|zombify')
		ezadmin_playerSelected2(userid)
	elif choice == 9:
		edit_zadmin(userid)

def rem_zadmin(userid):
	rzadmin = popuplib.easymenu('player_list6', '_popup_choice', rzadmin_playerSelected)
   	rzadmin.settitle('| Select a player |') 
   	adminlist2 = keyvalues.getKeyGroup('zadmin')
	count = 1
	for player in adminlist2:       
		r_userid = count
		r_name = es.keygetvalue('zadmin', player, 'name')
		listingr[count] = (player)
		rzadmin.addoption(r_userid, r_name)
		count = count + 1
	rzadmin.send(userid) 

def rzadmin_playerSelected(caller, target, menuname):
	playersteamid = listingr[target]
	es.keydelete('zadmin',playersteamid)
	es.keygroupsave('zadmin','|zombify')
	
